from typing import Any, Callable

from .events import *
from .node import Node

class WavelinkMixin:

    async def on_wavelink_error(self, listener: str, error: Exception): ...

    async def on_node_ready(self, node: Node): ...

    async def on_track_start(self, node: Node, payload: TrackStart): ...

    async def on_track_end(self, node: Node, payload: TrackEnd): ...

    async def on_track_stuck(self, node: Node, payload: TrackStuck): ...

    async def on_track_exception(self, node: Node, payload: TrackException): ...

    async def on_websocket_closed(self, node: Node, payload: WebsocketClosed): ...

    @staticmethod
    def listener(event: str) -> Callable[[], Callable[..., Any]]: ...
